#include <stdio.h>
#include <stdlib.h>
#include <fileops.h>
#include <points.h>
#include <tri.h>
#include <frame.h>
#include <autre.h>

char *save_filename=NULL;

int save_to_b3d(char *filename)
{
  model_save_a(this_model, filename);
	     
  return 0;
}

    
gint destroy_dialog(GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(GTK_WIDGET(data));
  
  return TRUE;
}

gint destroy_color_dialog(GtkWidget *widget, gpointer data)
{
  tris_add(p, p2, selected_point);
  draw_all_frames();
  gtk_widget_destroy(GTK_WIDGET(data));
  
  return TRUE;
}



gint save_as_ok(GtkWidget *widget, gpointer data)
{
  char *sf_tmp;

  sf_tmp=gtk_file_selection_get_filename(GTK_FILE_SELECTION(data));

  if(save_filename!=NULL)
    free(save_filename);
  save_filename=(char *)malloc(strlen(sf_tmp));
  strcpy(save_filename, sf_tmp);

  save_to_b3d(save_filename);

  gtk_widget_destroy(GTK_WIDGET(data));

  return TRUE;
}

gint show_save_dialog(GtkWidget *widget, gpointer data)
{
  GtkWidget *file_selector;

  file_selector=gtk_file_selection_new("Enregistrer Sous...");
  if(save_filename != NULL)
    gtk_file_selection_set_filename(GTK_FILE_SELECTION(file_selector), 
				    save_filename);
  gtk_widget_show(file_selector);

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->
				cancel_button), "clicked", 
		     GTK_SIGNAL_FUNC(destroy_dialog), file_selector);
  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->
				ok_button), "clicked", 
		     GTK_SIGNAL_FUNC(save_as_ok), file_selector);

  return TRUE;
}

gint new_dialog_ok(GtkWidget *widget, gpointer data)
{
  GList *ch;
  Point *p;

  ch=this_model->points;
  while(ch) {
    p=(Point *)ch->data;
    point_del_v(p);
    line_del_point(p); 
    tris_del_point(p); 
    selected_point=NULL;
    free(p);
    ch=this_model->points;
  }
  
  draw_all_frames();

  return FALSE;
}

gint show_new_dialog(GtkWidget *widget, gpointer data)
{
  GtkWidget *dialog, *label, *button;
  
  dialog=gtk_dialog_new();
  button=gtk_button_new_with_label("OK");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), button, 
		     FALSE, FALSE, 5);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(new_dialog_ok), NULL);
  gtk_signal_connect_after(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(destroy_dialog), dialog);
  gtk_widget_show(button);

  button=gtk_button_new_with_label("Cancel");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), button, 
		     FALSE, FALSE, 5);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(destroy_dialog), dialog);
  gtk_widget_show(button);


  label=gtk_label_new("  Si vous pressez OK maintenant,\n"
		      "  toutes les donnes vont tre perdues.\n"
		      "  \n"
		      "  Il ne faudra pas dire que je ne \n"
		      "  vous avez pas prvenu!!! \n"
		      "  ");
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label,
		     FALSE, FALSE, 5);

  gtk_widget_show(dialog);

  return TRUE;
}

gint save_menu_cb(GtkWidget *widget, gpointer data)
{
  if(save_filename == NULL) 
    return show_save_dialog(widget, data);
  else
    save_to_b3d(save_filename);
  
  return TRUE;
}

gint load_ok(GtkWidget *widget, gpointer data)
{
  char *filename=gtk_file_selection_get_filename(GTK_FILE_SELECTION(data));

  if(filename==NULL) {
    fprintf(stderr, "Gros probleme de chargement.\n");
    return TRUE;
  }
  
  new_dialog_ok(widget, NULL);
  this_model=model_load_a(filename);
  
  draw_all_frames();    

  return TRUE;
}
  
gint show_load_dialog(GtkWidget *widget, gpointer data)
{
  GtkWidget *file_selector;

  file_selector=gtk_file_selection_new("Ouvrir");
  gtk_widget_show(file_selector);

  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->
				cancel_button), "clicked", 
		     GTK_SIGNAL_FUNC(destroy_dialog), file_selector);
  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->
				ok_button), "clicked", 
		     GTK_SIGNAL_FUNC(load_ok), file_selector);
  gtk_signal_connect_after(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->
				      ok_button), "clicked", 
			   GTK_SIGNAL_FUNC(destroy_dialog), file_selector);

  return TRUE;
}


