#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <frame.h>
#include <toolbar.h>
#include <fileops.h>
#include <gadj.h>
#include <visu.h>

#define WIN_WIDTH widget->allocation.width
#define WIN_HEIGHT widget->allocation.height

mframe *frames[3];
int grid_width=10, grid_height=10, grid_snap=0, render=1;
int color_rouge=100, color_vert=100, color_bleu=100;
GtkWidget *table_child[4];
void show_color_dialog(GtkWidget *widget, gpointer data);


void _clear_pixmap(GdkPixmap *pixmap, int x, int y, 
		   double gwidth, double gheight)
{
  double a,b;
  GdkGC *gc;
  GdkColor color;
  GdkColormap *colormap;

  gc=gdk_gc_new(window->window);
  colormap=gdk_window_get_colormap(window->window);
  color.red=50000;
  color.green=50000;
  color.blue=50000;
  gdk_color_alloc(colormap, &color);
  gdk_gc_set_foreground(gc, &color);

  gdk_draw_rectangle(pixmap,
		     gc,
		     TRUE,
		     0,0, x,y);

  // la grille...

  if((gwidth<=0) || (gheight <=0))
    return;

  color.red=0;
  color.green=0;
  color.blue=0;
  gdk_color_alloc(colormap, &color);
  gdk_gc_set_foreground(gc, &color);

 for(a=0;a<(double)x;a+=gwidth) 
   gdk_draw_line(pixmap, gc,
		 (int)a,0,(int)(a),y);
 for(b=0;b<(double)y;b+=gheight)
   gdk_draw_line(pixmap, gc,
		 0,(int)b,x,(int)(b));

}

void clear_pixmap(mframe *fr)
{
  _clear_pixmap(fr->pixmap, fr->width, fr->height, 
		gadj_screen(fr->xadj, (double)grid_width),
		gadj_screen(fr->yadj, (double)grid_height)); 
}  

int hexpose_event(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
  mframe *fr=(mframe *)data;

  gdk_draw_pixmap(widget->window,
		  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		  fr->pixmap,
		  event->area.x, event->area.y,
		  event->area.x, event->area.y,
		  event->area.width, event->area.height);

  return FALSE;
}

void draw_all_frames(void)
{
  xyz_state=FRAME_XY;
  paxadj=frames[FRAME_XY]->xadj;
  payadj=frames[FRAME_XY]->yadj;
  clear_pixmap(frames[FRAME_XY]);
  lines_draw(frames[FRAME_XY]->pixmap);
  tris_draw(frames[FRAME_XY]->pixmap);
  point_draw(frames[FRAME_XY]->pixmap);
  gtk_widget_draw (frames[FRAME_XY]->drawing_area, NULL);
  
  xyz_state=FRAME_YZ;
  paxadj=frames[FRAME_YZ]->xadj;
  payadj=frames[FRAME_YZ]->yadj;
  clear_pixmap(frames[FRAME_YZ]);
  lines_draw(frames[FRAME_YZ]->pixmap);
  tris_draw(frames[FRAME_YZ]->pixmap);
  point_draw(frames[FRAME_YZ]->pixmap);
  gtk_widget_draw (frames[FRAME_YZ]->drawing_area, NULL);

  xyz_state=FRAME_XZ;
  paxadj=frames[FRAME_XZ]->xadj;
  payadj=frames[FRAME_XZ]->yadj;
  clear_pixmap(frames[FRAME_XZ]);
  lines_draw(frames[FRAME_XZ]->pixmap);
  tris_draw(frames[FRAME_XZ]->pixmap);
  point_draw(frames[FRAME_XZ]->pixmap);
  gtk_widget_draw (frames[FRAME_XZ]->drawing_area, NULL);

}

int hconfigure_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  mframe *fr=(mframe *)data;

  if(fr==frames[FRAME_XY]) 
    xyz_state=FRAME_XY;
  if(fr==frames[FRAME_YZ]) 
    xyz_state=FRAME_YZ;
  if(fr==frames[FRAME_XZ]) 
    xyz_state=FRAME_XZ;

  if(fr->pixmap)
    gdk_pixmap_unref(fr->pixmap);

  gadj_change(fr->xadj, 0.0, (double)WIN_WIDTH);
  gadj_change(fr->yadj, 0.0, (double)WIN_HEIGHT);

  fr->pixmap=gdk_pixmap_new(widget->window,
			    WIN_WIDTH,
			    WIN_HEIGHT,
			    -1);

  gdk_draw_rectangle(fr->pixmap,
		     widget->style->white_gc,
		     TRUE,
		     0, 0,
		     WIN_WIDTH,
		     WIN_HEIGHT);

  fr->width=WIN_WIDTH;
  fr->height=WIN_HEIGHT;
  clear_pixmap(fr);

  paxadj=fr->xadj;
  payadj=fr->yadj;
  lines_draw(fr->pixmap);
  tris_draw(fr->pixmap);
  point_draw(fr->pixmap);
  gtk_widget_draw (fr->drawing_area, NULL);
  return TRUE;
}

void hmotion_notify_event(GtkWidget *widget, GdkEventMotion *event, 
			  gpointer data)
{
  int x, y;
  double a,b;
  GdkModifierType state;
  mframe *fr=(mframe *)data;


  if(fr==frames[FRAME_XY]) 
    xyz_state=FRAME_XY;
  if(fr==frames[FRAME_YZ]) 
    xyz_state=FRAME_YZ;
  if(fr==frames[FRAME_XZ]) 
    xyz_state=FRAME_XZ;

    gdk_window_get_pointer (event->window, &x, &y, &state);

    x = event->x;    
    y = event->y;
    state = event->state;


  a=gadj_logical(fr->xadj, x);
  b=gadj_logical(fr->yadj, y);
  
  if(grid_snap) {
    a=grid_width*(int)rint(a/((double)grid_width));
    b=grid_height*(int)rint(b/((double)grid_height));
  }
  
  if(state & GDK_BUTTON1_MASK && fr->pixmap != NULL) {
    if(click_mode[1] == CM_POINT_SEL)
      point_move_selected(a, b);
  }

  if(state & GDK_BUTTON2_MASK && fr->pixmap != NULL) {
    if(click_mode[2] == CM_POINT_SEL)
      point_move_selected(a, b);
  }

  if(state & GDK_BUTTON3_MASK && fr->pixmap != NULL) {
    if(click_mode[3] == CM_POINT_SEL)
      point_move_selected(a, b);
  }

  draw_all_frames();
  gtk_widget_draw(widget, NULL);
}

int hbutton_press_event(GtkWidget *widget, 
			GdkEventButton *event, 
			gpointer data)
{
  double x,y;
  Point *np;
  mframe *fr=(mframe *)data;

  if(fr==frames[FRAME_XY]) 
    xyz_state=FRAME_XY;
  if(fr==frames[FRAME_YZ]) 
    xyz_state=FRAME_YZ;
  if(fr==frames[FRAME_XZ]) 
    xyz_state=FRAME_XZ;
  
  x=gadj_logical(fr->xadj, event->x);
  y=gadj_logical(fr->yadj, event->y);

  if(grid_snap) {
    x=grid_width*(int)rint(x/((double)grid_width));
    y=grid_height*(int)rint(y/((double)grid_height));
  }

  if(fr->pixmap!=NULL)
    switch(click_mode[event->button]) {  
    case CM_POINT_ADD:
      np=point_add(x, y);
      break;
    case CM_POINT_SEL:
      clear_pixmap(fr);
      point_select(x, y);
      break;
    case CM_POINT_DEL:
      point_select(x, y);
      p=selected_point;
      point_del_v(p); 
      /* detruit toutes les lignes qui utilisent ce point */	 
      line_del_point(p);
      tris_del_point(p); 
      selected_point=NULL;
      free(p);
      break;
    case CM_LINE_ADD:
      point_select(x, y);
      if(selected_point!=NULL)
	click_mode[event->button]=CM_LINE_ADD_2;
      break;
    case CM_LINE_ADD_2:
      if(selected_point==NULL) {
	click_mode[event->button]=CM_LINE_ADD;
	break;
      }
      p=selected_point;
      point_select(x, y);
      if(selected_point!=NULL) 
	line_add(p, selected_point);
      click_mode[event->button]=CM_LINE_ADD;
      break;
    case CM_LINE_SEL:
      point_select(x, y);
      if(selected_point!=NULL)
	click_mode[event->button]=CM_LINE_SEL_2;
      break;
    case CM_LINE_SEL_2:
      if(selected_point==NULL) {
	click_mode[event->button]=CM_LINE_SEL;
	break;
      }
      p=selected_point;
      point_select(x, y);
      if(selected_point!=NULL)
	line_sel(p, selected_point);
      click_mode[event->button]=CM_LINE_SEL;
      break;
    case CM_LINE_DEL:
      point_select(x, y);
      if(selected_point!=NULL)
	click_mode[event->button]=CM_LINE_DEL_2;
      break;
    case CM_LINE_DEL_2:
      if(selected_point==NULL) {
	click_mode[event->button]=CM_LINE_DEL;
	break;
      }
      p=selected_point;
      point_select(x, y);
      if(selected_point!=NULL)
	line_del(p, selected_point);
      click_mode[event->button]=CM_LINE_DEL;
      break;

    case CM_TRI_ADD:
      point_select(x, y);
      if(selected_point!=NULL) 
	click_mode[event->button]=CM_TRI_ADD_2;
      break;
    case CM_TRI_ADD_2:
      if(selected_point==NULL) {
	click_mode[event->button]=CM_TRI_ADD;
	break;
      }
      p=selected_point;
      point_select(x, y);
      if(selected_point==NULL) 
	click_mode[event->button]=CM_TRI_ADD;
      else
	click_mode[event->button]=CM_TRI_ADD_3;
      break;
    case CM_TRI_ADD_3:
      if(selected_point==NULL) {
	click_mode[event->button]=CM_TRI_ADD;
	break;
      }
      p2=selected_point;
      point_select(x, y);
      if(selected_point) {
	show_color_dialog(NULL, NULL);
      }
      click_mode[event->button]=CM_TRI_ADD;
      break;
      
    case CM_TRI_SEL:
      point_select(x, y);
      if(selected_point!=NULL) 
	click_mode[event->button]=CM_TRI_SEL_2;
      break;
    case CM_TRI_SEL_2:
      if(selected_point==NULL) {
	click_mode[event->button]=CM_TRI_SEL;
	break;
      }
      p=selected_point;
      point_select(x, y);
      if(selected_point==NULL) 
	click_mode[event->button]=CM_TRI_SEL;
      else
	click_mode[event->button]=CM_TRI_SEL_3;
      break;
    case CM_TRI_SEL_3:
      if(selected_point==NULL) {
	click_mode[event->button]=CM_TRI_SEL;
	break;
      }
      p2=selected_point;
      point_select(x, y);
      if(selected_point)
	tris_sel(p, p2, selected_point);
      click_mode[event->button]=CM_TRI_SEL;
      break;

    case CM_TRI_DEL:
      point_select(x, y);
      if(selected_point!=NULL) 
	click_mode[event->button]=CM_TRI_DEL_2;
      break;
    case CM_TRI_DEL_2:
      if(selected_point==NULL) {
	click_mode[event->button]=CM_TRI_DEL;
	break;
      }
      p=selected_point;
      point_select(x, y);
      if(selected_point==NULL) 
	click_mode[event->button]=CM_TRI_DEL;
      else
	click_mode[event->button]=CM_TRI_DEL_3;
      break;
    case CM_TRI_DEL_3:
      if(selected_point==NULL) {
	click_mode[event->button]=CM_TRI_DEL;
	break;
      }
      p2=selected_point;
      point_select(x, y);
      if(selected_point)
	tris_del(p, p2, selected_point);
      click_mode[event->button]=CM_TRI_DEL;
      break;

    default:
      break;
  }

  draw_all_frames();

  return TRUE;
}

gint expand_cb(GtkWidget *widget, gpointer data)
{
  int c;
  static int ms=1;


  /* pour 4 fenetre remplacer les 3 par des 4 eh oui !!!*/
  /* la 4eme c la visualisation*/

  if(ms) {
    for(c=0;c<4;c++) 
      if(table_child[c]!=(GtkWidget *)data) gtk_widget_hide(table_child[c]);
    gtk_table_set_homogeneous(GTK_TABLE(table), 0);
  } 
  else {
    for(c=0;c<4;c++) 
      if(table_child[c]!=(GtkWidget *)data) gtk_widget_show(table_child[c]);
    gtk_table_set_homogeneous(GTK_TABLE(table), 1);
  }

  ms=ms?0:1;

  return FALSE;
}
       

mframe *init_mframe(char *text)
{
  mframe *fr;
  GtkWidget *drawing_area, *label, *hbox, *frame;

  fr=(mframe *)malloc(sizeof(mframe));

  drawing_area = gtk_drawing_area_new();
  gtk_widget_show(drawing_area);
  
  gtk_signal_connect (GTK_OBJECT (drawing_area), "expose_event",
		      (GtkSignalFunc) hexpose_event,        (gpointer)fr);
  gtk_signal_connect (GTK_OBJECT(drawing_area),  "configure_event",
		      (GtkSignalFunc) hconfigure_event,     (gpointer)fr);
  gtk_signal_connect (GTK_OBJECT (drawing_area), "motion_notify_event",
		      (GtkSignalFunc) hmotion_notify_event, (gpointer)fr);
  gtk_signal_connect (GTK_OBJECT (drawing_area), "button_press_event",
		      (GtkSignalFunc) hbutton_press_event,  (gpointer)fr);
  
  gtk_widget_set_events (drawing_area, GDK_EXPOSURE_MASK
			 | GDK_LEAVE_NOTIFY_MASK
			 | GDK_BUTTON_PRESS_MASK
			 | GDK_BUTTON_MOTION_MASK
			 | GDK_POINTER_MOTION_HINT_MASK);
  
 
  fr->drawing_area=drawing_area;

  fr->pixmap=NULL;

  label=gtk_button_new_with_label(text);
  gtk_widget_show(label);

  frame=gtk_frame_new(NULL);
  gtk_widget_show(frame);
  gtk_container_add(GTK_CONTAINER(frame), drawing_area);
  gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_OUT);

  hbox=gtk_vbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(hbox), frame, TRUE, TRUE, 0);
  gtk_widget_show(hbox);

  gtk_signal_connect(GTK_OBJECT(label), "clicked",
		     GTK_SIGNAL_FUNC(expand_cb), (gpointer)hbox);

  fr->xadj=gadj_new(-1,-1);
  fr->yadj=gadj_new(-1,-1);

  fr->scw=hbox;
  return fr;
}


GtkWidget *glp_new_frame(GtkWidget *glwidget)
{
  GtkWidget *button, *vbox;

  vbox=gtk_vbox_new(FALSE, 0);
  button=gtk_button_new_with_label("Visualisation");

  gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), glwidget, TRUE, TRUE, 0);

  gtk_widget_show(vbox);
  gtk_widget_show(button);

  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(expand_cb), (gpointer)vbox);
  
  return vbox;
}

gint commit_color_change_rouge(GtkWidget *widget, gpointer data)
{
  color_rouge=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(data));
  return FALSE;
}

gint commit_color_change_vert(GtkWidget *widget, gpointer data)
{
  color_vert=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(data)); 
  return FALSE;
}

gint commit_color_change_bleu(GtkWidget *widget, gpointer data)
{
  color_bleu=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(data)); 
  return FALSE;
}

void show_color_dialog(GtkWidget *widget, gpointer data)
{
  GtkWidget *dialog, *button, *frame1, *spinb1, *frame2, *spinb2, *frame3, *spinb3;
  GtkAdjustment *adj1, *adj2, *adj3;

  dialog=gtk_dialog_new();
  gtk_widget_set_usize(dialog, 200, 200);

  frame1=gtk_frame_new("Rouge:");
  adj1=(GtkAdjustment *)gtk_adjustment_new(color_rouge, 0, 65535, 1, 0,0);
  spinb1=gtk_spin_button_new(adj1, 0,0);
  gtk_container_add(GTK_CONTAINER(frame1), spinb1);
  gtk_container_set_border_width(GTK_CONTAINER(frame1), 5);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), 
		     frame1, TRUE, TRUE, 0);
  gtk_widget_show(frame1);
  gtk_widget_show(spinb1);

  frame2=gtk_frame_new("Vert:");
  adj2=(GtkAdjustment *)gtk_adjustment_new(color_vert, 0, 65535, 1, 0,0);
  spinb2=gtk_spin_button_new(adj2, 0,0);
  gtk_container_add(GTK_CONTAINER(frame2), spinb2);
  gtk_container_set_border_width(GTK_CONTAINER(frame2), 5);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), 
		     frame2, TRUE, TRUE, 0);
  gtk_widget_show(frame2);
  gtk_widget_show(spinb2);
 
  frame3=gtk_frame_new("Bleu:");
  adj3=(GtkAdjustment *)gtk_adjustment_new(color_bleu, 0, 65535, 1, 0,0);
  spinb3=gtk_spin_button_new(adj3, 0,0);
  gtk_container_add(GTK_CONTAINER(frame3), spinb3);
  gtk_container_set_border_width(GTK_CONTAINER(frame3), 5);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), 
		     frame3, TRUE, TRUE, 0);
  gtk_widget_show(frame3);
  gtk_widget_show(spinb3);


  button=gtk_button_new_with_label("OK");
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(commit_color_change_rouge), (gpointer)spinb1);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(commit_color_change_vert), (gpointer)spinb2);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(commit_color_change_bleu), (gpointer)spinb3);

  gtk_signal_connect_after(GTK_OBJECT(button), "clicked",
			   GTK_SIGNAL_FUNC(destroy_color_dialog), (gpointer)dialog);


  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), 
		     button, FALSE, FALSE, 0);
  gtk_widget_show(button);
  gtk_widget_show(dialog);
}

