#include <stdlib.h>
#include <lines.h>
#include <points.h>

Line *selected_line=NULL;

void line_add(Point *p1, Point *p2)
{
  Line *ln;
  ln=(Line *)malloc(sizeof(Line));
  
  ln->one=p1;ln->two=p2;
  this_model->lines=g_list_append(this_model->lines, (gpointer)ln);
}

void line_sel(Point *p1, Point *p2)
{
  Line *ln;
  GList *cl;

  if(this_model->lines==NULL)
    return;

  for(cl=this_model->lines;cl; cl=cl->next) {
    ln=(Line *)cl->data;
    if(((ln->one==p1)&&(ln->two==p2))||
       ((ln->one==p2)&&(ln->two==p1))) { 
      selected_line=ln;
      break;
    }
  }
}
  

void draw_line(GdkDrawable *drawable, int x1, int y1, int x2, int y2, 
	       int r, int g, int b)
{
  GdkGC *gc;
  GdkColor color;
  GdkColormap *colormap;

  gc=gdk_gc_new(window->window);
  colormap=gdk_window_get_colormap(window->window);
  color.red=r;
  color.green=g;
  color.blue=b;
  gdk_color_alloc(colormap, &color);
  gdk_gc_set_foreground(gc, &color);

  gdk_draw_line(drawable, gc,
		x1,y1,x2,y2);
}

void lines_draw(GdkDrawable *drawable)
{
  GList *cl;
  Line *ln;

  if(this_model->lines==NULL)
    return;

  for(cl=this_model->lines;cl; cl=cl->next) {
    ln=(Line *)cl->data;
    draw_line(drawable, point_get_lx(ln->one), point_get_ly(ln->one), 
	      point_get_lx(ln->two), point_get_ly(ln->two), 
	      0,0,0); 
  } 
  if(selected_line) {
    ln=selected_line; 
    draw_line(drawable, point_get_lx(ln->one), point_get_ly(ln->one), 
	      point_get_lx(ln->two), point_get_ly(ln->two), 32737,0,0);
  } 
} 
  
void line_del_point(Point *p){

  GList *cl;
  Line *ln;


  if(this_model->lines==NULL)
    return;

  for(cl=this_model->lines;cl; ) {
    ln=(Line *)cl->data;
    if((ln->one==p) || (ln->two==p)) {
      this_model->lines=g_list_remove_link(this_model->lines, 
					   g_list_find(this_model->lines, 
						       (gpointer)ln));
      free(ln);
      cl=this_model->lines;
      if(cl==NULL) return;
    } else 
      cl=cl->next;
  }
}

void line_del(Point *p1, Point *p2)
{
  Line *ln;
  GList *cl;
  
  if(this_model->lines==NULL)
    return;
  
  for(cl=this_model->lines;cl; cl=cl->next) {
    ln=(Line *)cl->data;
    if(((ln->one==p1)&&(ln->two==p2))||
       ((ln->one==p2)&&(ln->two==p1))) {
      this_model->lines=g_list_remove_link(this_model->lines,
					   g_list_find(this_model->lines, 
						       (gpointer)ln));
      free(ln);
      break;
    }
  }
}
