#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <toolbar.h>
#include <points.h>
#include <lines.h>
#include <frame.h>
#include <menu.h>
#include <visu.h>

#define WIN_WIDTH widget->allocation.width
#define WIN_HEIGHT widget->allocation.height

int click_mode[4];
GtkWidget *window, *label, *table;
GdkPixmap *pixmap=NULL;

void quit(GtkWidget *widget, gpointer data)
{
  gtk_exit(0);
}

int main(int argc, char **argv)
{
  GtkWidget *vbox, *frame, *menu;
  mframe *fr;
  visuframe *glp;
  
  click_mode[1]=CM_POINT_ADD;
  click_mode[2]=CM_TRI_ADD;
  click_mode[3]=CM_POINT_SEL;

  gtk_init(&argc, &argv);
  
  gdk_rgb_set_verbose(TRUE);
  
  gdk_rgb_init();

  this_model=model_new();
  
  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name(window, "Visu3D");
  gtk_widget_set_usize(window, 600,600);

  vbox=gtk_vbox_new(FALSE, 0);
  
  gtk_container_add(GTK_CONTAINER(window), vbox);
  gtk_widget_show(vbox);
  
  gtk_signal_connect(GTK_OBJECT(window), "destroy",
		     GTK_SIGNAL_FUNC(quit), NULL);
  
  gtk_widget_realize(window);

  table=gtk_table_new(2,2,1);
  gtk_widget_show(table);
  
  fr=init_mframe("Vue de Face (XY)");
  gtk_table_attach_defaults(GTK_TABLE(table), fr->scw, 0,1,0,1);
  frames[FRAME_XY]=fr;
  table_child[0]=fr->scw;

  fr=init_mframe("Vue de Cot (YZ)");
  gtk_table_attach_defaults(GTK_TABLE(table), fr->scw, 1,2,0,1);
  frames[FRAME_YZ]=fr;
  table_child[1]=fr->scw;

  fr=init_mframe("Vue de Dessus (XZ)");
  gtk_table_attach_defaults(GTK_TABLE(table), fr->scw, 0,1,1,2);
  frames[FRAME_XZ]=fr;
  table_child[2]=fr->scw;

  glp=init_visu("Visualisation");
  gtk_table_attach_defaults(GTK_TABLE(table), glp->scw, 1,2,1,2);
  table_child[3]=glp->scw;
  /************************************************************************/
  


  /************************************************************************/



  menu=get_menu_bar(window);
  gtk_menu_bar_set_shadow_type(GTK_MENU_BAR(menu), GTK_SHADOW_OUT);
  gtk_box_pack_start(GTK_BOX(vbox), menu, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), create_toolbar(), FALSE, FALSE, 0);

  gtk_box_pack_start(GTK_BOX(vbox), table, TRUE, TRUE, 0);

  frame=gtk_frame_new(NULL);
  gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
  label=gtk_label_new("Visu3D");
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  gtk_container_add(GTK_CONTAINER(frame), label);
  gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 0);
  gtk_widget_show(label);
  gtk_widget_show(frame);

  gtk_widget_show(window);

  gtk_main();

  return 0;
}
