#include <menu.h>
#include <fileops.h>

void show_about(GtkWidget *widget, gpointer data);
void show_grid_dialog(GtkWidget *widget, gpointer data);
void toggle_switch(GtkWidget *widget, gpointer data);
void toggle_radio(GtkWidget *widget, guint data);

static GtkItemFactoryEntry menu_items[] = {
  {"/_Fichier",                     NULL,         NULL,                                0,          "<Branch>"},
  {"/Fichier/_Nouveau",             "<control>N", GTK_SIGNAL_FUNC(show_new_dialog),    0,          NULL},
  {"/Fichier/_Ouvrir",              "<control>O", GTK_SIGNAL_FUNC(show_load_dialog),   0,          NULL},
  {"/Fichier/_Enregistrer",         "<control>E", GTK_SIGNAL_FUNC(save_menu_cb),       0,          NULL},
  {"/Fichier/Enregistrer Sous",     NULL,         GTK_SIGNAL_FUNC(show_save_dialog),   0,          NULL},
  {"/Fichier/sep1",                 NULL,         NULL,                                0,          "<Separator>"},
  {"/Fichier/_Quitter",             "<control>Q", gtk_main_quit,                       0,          NULL},
  {"/Options",                      NULL,         NULL,                                0,          "<Branch>"},
  {"/Options/Espacement Grille...", NULL,         show_grid_dialog,                    0,          NULL},
  {"/Options/Accrocher la Grille",  NULL,         toggle_switch,                       0,          "<ToggleItem>"},
  {"/Visualisation",                NULL,         NULL,                                0,          "<Branch>"},
  {"/Visualisation/Fil de Fer",     NULL,         toggle_radio,                        1,          "<RadioItem>"},
  {"/Visualisation/Faces Caches",  NULL,         toggle_radio,                        2,          "/Visualisation/Fil de Fer"},
  {"/Visualisation/Flat Filling",   NULL,         toggle_radio,                        3,          "/Visualisation/Fil de Fer"},
  {"/Visualisation/Lambert Shading",NULL,         toggle_radio,                        4,          "/Visualisation/Fil de Fer"},
  {"/Visualisation/Gouraud Shading",NULL,         toggle_radio,                        5,          "/Visualisation/Fil de Fer"},
  {"/Aide",                         NULL,         NULL,                                0,          "<LastBranch>"},
  {"/Aide/_A Propos de",            "<control>A", show_about,                          0,          NULL}, 
};

void toggle_switch(GtkWidget *widget, gpointer data)
{
  grid_snap=grid_snap?0:1;
}

void toggle_radio(GtkWidget *widget, guint data)
{
  render=data;
}

void ab_click_button(GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(GTK_WIDGET(data));
}

gint commit_grid_change(GtkWidget *widget, gpointer data)
{
  grid_width=grid_height=
    gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(data));
  
  draw_all_frames();
  return FALSE;
}

void show_grid_dialog(GtkWidget *widget, gpointer data)
{
  GtkWidget *dialog, *button, *frame, *spinb;
  GtkAdjustment *adj;

  dialog=gtk_dialog_new();
  
  frame=gtk_frame_new("Espacement Grille:");
  adj=(GtkAdjustment *)gtk_adjustment_new(grid_width, 1, 200, 1, 0,0);
  spinb=gtk_spin_button_new(adj, 0,0);
  gtk_container_add(GTK_CONTAINER(frame), spinb);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 5);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), 
		     frame, TRUE, TRUE, 0);
  gtk_widget_show(frame);
  gtk_widget_show(spinb);

  button=gtk_button_new_with_label("OK");
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(commit_grid_change), (gpointer)spinb);
  gtk_signal_connect_after(GTK_OBJECT(button), "clicked",
			   GTK_SIGNAL_FUNC(destroy_dialog), (gpointer)dialog);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), 
		     button, FALSE, FALSE, 0);
  gtk_widget_show(button);
  gtk_widget_show(dialog);
}

void show_about(GtkWidget *widget, gpointer data)
{
  GtkWidget *label, *button, *frame, *dialog;

  dialog=gtk_dialog_new();
  gtk_widget_set_name(dialog, "A Propos de");
  gtk_container_set_border_width(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), 5);
  
  label=gtk_label_new(" Cet excellent logiciel a etait fait par :  \n" 
		      " KHELIDJ Ghalleb  ghalleb@mime.up8.edu\n"
		      " ADELBERT Erik    erika@mime.up8.edu \n"
		      " \n"
		      " Maitrise MIME 2000/20001");
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  gtk_widget_show(label);

  frame=gtk_frame_new("Visu3D");
  gtk_container_set_border_width(GTK_CONTAINER(frame), 3);
  gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_OUT);
  gtk_container_add(GTK_CONTAINER(frame), label);
  gtk_widget_show(frame);
  
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), 
		     frame, FALSE, FALSE, 5);
  
  button=gtk_button_new_with_label("OK");
  gtk_widget_show(button);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
		     GTK_SIGNAL_FUNC(ab_click_button), dialog);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), 
		     button, FALSE, FALSE, 0);
  
  gtk_widget_show(dialog);
}

GtkWidget *get_menu_bar(GtkWidget *window)
{
  GtkWidget *menubar;
  int nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);
  GtkItemFactory *item_factory;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new();

  item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", 
				       accel_group);
  gtk_item_factory_create_items(item_factory, nmenu_items, menu_items, NULL);
  gtk_accel_group_attach (accel_group, GTK_OBJECT (window));

  menubar=gtk_item_factory_get_widget(item_factory, "<main>");
  gtk_widget_show(menubar);

  return menubar;
}
