#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <points.h>
#include <frame.h>
#include <gadj.h>

int xyz_state=-1;
gadj *paxadj, *payadj;
Point *selected_point=NULL, *p=NULL, *p2=NULL;

void draw_brush(GdkDrawable *drawable, gdouble x, gdouble y)
{
  GdkRectangle update_rect;

  update_rect.x = x - 5;
  update_rect.y = y - 5;
  update_rect.width = 10;
  update_rect.height = 10;
  gdk_draw_rectangle (drawable,
		      window->style->black_gc,
		      FALSE,
		      update_rect.x, update_rect.y,
		      update_rect.width-1, update_rect.height-1);
}

void draw_brush_filled(GdkDrawable *drawable, gdouble x, gdouble y)
{
  GdkRectangle update_rect;

  update_rect.x = x - 5;
  update_rect.y = y - 5;
  update_rect.width = 10;
  update_rect.height = 10;
  gdk_draw_rectangle (drawable,
		      window->style->black_gc,
		      TRUE,
		      update_rect.x, update_rect.y,
		      update_rect.width-1, update_rect.height-1);
}

void point_add_v(Point *np)
{
  this_model->points=g_list_append(this_model->points, (gpointer)np);
}


Point *point_add(double x, double y)
{
  Point *tp;

  tp=(Point *)malloc(sizeof(Point));
  
  if(xyz_state==FRAME_XY) {
    tp->v[0]=x;
    tp->v[1]=y;
    tp->v[2]=50;
  }
  if(xyz_state==FRAME_YZ) {
    tp->v[1]=y;
    tp->v[2]=x;
    tp->v[0]=50;
  }
  if(xyz_state==FRAME_XZ) {
    tp->v[0]=x;
    tp->v[2]=y;
    tp->v[1]=50;
  }
  this_model->points=g_list_append(this_model->points, (gpointer)tp);
  return tp;
}


void point_del(double x, double y)
{
  GList *cl;
  Point *tp;
  
  for(cl=this_model->points; cl; cl=cl->next) {
    tp=(Point *)cl->data;
    if((abs(x-tp->v[0])<5) && (abs(y-tp->v[1])<5)) {
      this_model->points=g_list_remove_link(this_model->points, cl);
      free(tp);
      return;
    }
  }
}


void point_del_v(Point *np)
{
  GList *cl;
  if(np!=NULL && this_model!=NULL) {
    cl=g_list_find(this_model->points, (gpointer)np);
    if(cl!=NULL)
      this_model->points=g_list_remove(this_model->points, cl->data);
  }
}


void point_del_selected(void)
{
  GList *cl;

  if(selected_point) {
    cl=g_list_find(this_model->points, (gpointer)selected_point);
    this_model->points=g_list_remove(this_model->points, cl->data);
  }
}


void point_draw(GdkDrawable *drawable)
{
  GList *cl;
  Point *tp;
  double x,y;
  
  if(this_model->points==NULL) return;

  for(cl=this_model->points; cl; cl=cl->next) {
    tp=(Point *)cl->data;
    switch(xyz_state) {
    case FRAME_XY:
      x=gadj_screen(paxadj, tp->v[0]);
      y=gadj_screen(payadj, tp->v[1]);
      break;
    case FRAME_YZ:
      x=gadj_screen(paxadj, tp->v[2]);
      y=gadj_screen(payadj, tp->v[1]);
      break;
    case FRAME_XZ:
      x=gadj_screen(paxadj, tp->v[0]);
      y=gadj_screen(payadj, tp->v[2]);
      break;
    default:
      x=-1;
      y=-1;
      return;
    }      
    draw_brush(drawable, x, y);
  }

  if(selected_point!=NULL) {
    switch(xyz_state) {
    case FRAME_XY:
      x=gadj_screen(paxadj, selected_point->v[0]);
      y=gadj_screen(payadj, selected_point->v[1]);
      break;
    case FRAME_YZ:
      x=gadj_screen(paxadj, selected_point->v[2]);
      y=gadj_screen(payadj, selected_point->v[1]);
      break;
    case FRAME_XZ:
      x=gadj_screen(paxadj, selected_point->v[0]);
      y=gadj_screen(payadj, selected_point->v[2]);
      break;
    default:
      x=-1;
      y=-1;
      return;
    }
    draw_brush_filled(drawable, x, y);
  }
}


void point_select_v(Point *np)
{
  if(np!=NULL)
    selected_point=np;
}


void point_select(double x, double y)
{
  GList *cl;
  Point *tp;
  
  for(cl=this_model->points; cl; cl=cl->next) {
    tp=(Point *)cl->data;
    if(xyz_state==FRAME_XY) 
      if((abs(x-tp->v[0])<5) && (abs(y-tp->v[1])<5)) {
	selected_point=tp;
	return;
      }    
    if(xyz_state==FRAME_YZ) 
      if((abs(x-tp->v[2])<5) && (abs(y-tp->v[1])<5)) {
	selected_point=tp;
	return;
      }
    if(xyz_state==FRAME_XZ) 
      if((abs(x-tp->v[0])<5) && (abs(y-tp->v[2])<5)) {
	selected_point=tp;
	return;
      }
  }
  
   
  selected_point=NULL;
}


void point_move_selected(double x, double y)
{
  double a,b;

  if(selected_point==NULL) return;
  switch(xyz_state) {
  case FRAME_XY:
    a=gadj_screen(paxadj, selected_point->v[0]);
    b=gadj_screen(payadj, selected_point->v[1]);
    selected_point->v[0]=x;  selected_point->v[1]=y;
    break;
  case FRAME_YZ:
    a=gadj_screen(paxadj, selected_point->v[2]);
    b=gadj_screen(payadj, selected_point->v[1]);
    selected_point->v[2]=x;  selected_point->v[1]=y;
    break;
  case FRAME_XZ:
    a=gadj_screen(paxadj, selected_point->v[0]);
    b=gadj_screen(payadj, selected_point->v[2]);
    selected_point->v[0]=x;  selected_point->v[2]=y;
    break;
  default:
    a=-1;
    b=-1;
    return;
  }
}


int point_get_lx(Point *p)
{
  switch(xyz_state) {
  case FRAME_XY:
    return gadj_screen(paxadj, p->v[0]);
  case FRAME_YZ:
    return gadj_screen(paxadj, p->v[2]);
  case FRAME_XZ:
    return gadj_screen(paxadj, p->v[0]);
  default:
    return -1;
  }
}


int point_get_ly(Point *p)
{
  switch(xyz_state) {
  case FRAME_XY:
    return gadj_screen(payadj, p->v[1]);
  case FRAME_YZ:
    return gadj_screen(payadj, p->v[1]);
  case FRAME_XZ:
    return gadj_screen(payadj, p->v[2]);
  default:
    return -1;
  }
}
