#include <stdio.h>
#include <stdlib.h>
#include <tri.h>
#include <lines.h>

extern int color_rouge, color_vert, color_bleu;

Tri *selected_tri=NULL;

void draw_tri(GdkDrawable *drawable, int x1, int y1, int x2, int y2, 
	      int x3, int y3, int r, int g, int b)
{
  draw_line(drawable, x1,y1,x2,y2,r,g,b);
  draw_line(drawable, x1,y1,x3,y3,r,g,b);
  draw_line(drawable, x3,y3,x2,y2,r,g,b);
}

void tris_draw(GdkDrawable *drawable)
{
  GList *cl;
  Tri *tn;

  if(this_model->triangles==NULL)
    return;
  
  for(cl=this_model->triangles;cl;cl=cl->next) {
    tn=(Tri *)cl->data;
    draw_tri(drawable, 
	     point_get_lx(tn->verticies[0]), point_get_ly(tn->verticies[0]), 
	     point_get_lx(tn->verticies[1]), point_get_ly(tn->verticies[1]), 
	     point_get_lx(tn->verticies[2]), point_get_ly(tn->verticies[2]),
	     65535,65535,65535);
  }
  if(selected_tri) {
    tn=selected_tri;
    draw_tri(drawable, 
	     point_get_lx(tn->verticies[0]), point_get_ly(tn->verticies[0]), 
	     point_get_lx(tn->verticies[1]), point_get_ly(tn->verticies[1]), 
	     point_get_lx(tn->verticies[2]), point_get_ly(tn->verticies[2]),
	     0,0,32767);
  }
}

void tris_add(Point *p1, Point *p2, Point *p3)
{
  Tri *tn;
  tn=(Tri *)malloc(sizeof(Tri));
  
  tn->verticies[0]=p1;tn->verticies[1]=p2;tn->verticies[2]=p3;
  
  tn->rouge=color_rouge;
  tn->vert=color_vert;
  tn->bleu=color_bleu;

  this_model->triangles=g_list_append(this_model->triangles, (gpointer)tn);
}

void tris_sel(Point *p1, Point *p2, Point *p3)
{
  Tri *tn;
  GList *cl;
  tn=(Tri *)malloc(sizeof(Tri));
  
  if(this_model->triangles==NULL)
    return; 

  for(cl=this_model->triangles;cl;cl=cl->next) {
    tn=(Tri *)cl->data;
    if(((tn->verticies[0]==p1)&&(tn->verticies[1]==p2)&&
	(tn->verticies[2]==p3)) ||
       ((tn->verticies[0]==p1)&&(tn->verticies[2]==p2)&&
	(tn->verticies[1]==p3)) ||
       ((tn->verticies[1]==p1)&&(tn->verticies[0]==p2)&&
	(tn->verticies[2]==p3)) ||
       ((tn->verticies[1]==p1)&&(tn->verticies[2]==p2)&&
	(tn->verticies[0]==p3)) ||
       ((tn->verticies[2]==p1)&&(tn->verticies[1]==p1)&&
	(tn->verticies[1]==p3)) ||
       ((tn->verticies[2]==p1)&&(tn->verticies[1]==p2)&&
	(tn->verticies[0]==p3))) {
      selected_tri=tn;
      break;
    }
  }
}

void tris_del(Point *p1, Point *p2, Point *p3)
{
  Tri *tn;
  GList *cl;
  tn=(Tri *)malloc(sizeof(Tri));
  
  if(this_model->triangles==NULL)
    return; 

  for(cl=this_model->triangles;cl;cl=cl->next) {
    tn=(Tri *)cl->data;
    if(((tn->verticies[0]==p1)&&(tn->verticies[1]==p2)&&
	(tn->verticies[2]==p3)) ||
       ((tn->verticies[0]==p1)&&(tn->verticies[2]==p2)&&
	(tn->verticies[1]==p3)) ||
       ((tn->verticies[1]==p1)&&(tn->verticies[0]==p2)&&
	(tn->verticies[2]==p3)) ||
       ((tn->verticies[1]==p1)&&(tn->verticies[2]==p2)&&
	(tn->verticies[0]==p3)) ||
       ((tn->verticies[2]==p1)&&(tn->verticies[1]==p1)&&
	(tn->verticies[1]==p3)) ||
       ((tn->verticies[2]==p1)&&(tn->verticies[1]==p2)&&
	(tn->verticies[0]==p3))) {        
      this_model->triangles=g_list_remove_link(this_model->triangles, 
			       g_list_find(this_model->triangles, 
					   (gpointer)tn));
      free(tn);						      
      break;
    }
  }
}

void tris_del_point(Point *p)
{
  GList *cl;
  Tri *tn;

  if(this_model->triangles==NULL)
    return;
  
  for(cl=this_model->triangles;cl; ) {
    tn=(Tri *)cl->data;
    if((tn->verticies[0]==p) || (tn->verticies[1]==p) || 
       (tn->verticies[2]==p)) { 
      this_model->triangles=g_list_remove_link(this_model->triangles, 
				  g_list_find(this_model->triangles, 
					      (gpointer)tn));
      free(tn);
      cl=this_model->triangles;
      if(cl==NULL) return;
    } else 
      cl=cl->next;
  }
}
