#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <frame.h>
#include <toolbar.h>
#include <fileops.h>
#include <gadj.h>
#include <visu.h>

#define WIN_WIDTH widget->allocation.width
#define WIN_HEIGHT widget->allocation.height

visuframe *visu;

int x_base=0, y_base=0;
int rotat_x=0, rotat_y=0, scale_y=0, trans_x=0, trans_y=0;
int rotat_x_base=0, rotat_y_base=0, scale_y_base=0, trans_x_base=0, trans_y_base=0;

int hconfigure_visu_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{

  visuframe *fr=(visuframe *)data;

  if(fr->pixmap)
    gdk_pixmap_unref(fr->pixmap);
  
  gadj_change(fr->xadj, 0.0, (double)WIN_WIDTH);
  gadj_change(fr->yadj, 0.0, (double)WIN_HEIGHT);
  
  fr->pixmap=gdk_pixmap_new(widget->window, WIN_WIDTH, WIN_HEIGHT, -1);
  
  gdk_draw_rectangle(fr->pixmap, widget->style->white_gc, TRUE, 0, 0, WIN_WIDTH, WIN_HEIGHT);
    
  fr->width=WIN_WIDTH;
  fr->height=WIN_HEIGHT;
    
  paxadj=fr->xadj;
  payadj=fr->yadj;
  draw_visu(fr->pixmap);
  gtk_widget_draw (fr->drawing_area, NULL);
    
  return TRUE;
}

int hexpose_visu_event(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
  visuframe *fr=(visuframe *)data;

  gdk_draw_pixmap(widget->window,
		  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		  fr->pixmap,
		  event->area.x, event->area.y,
		  event->area.x, event->area.y,
		  event->area.width, event->area.height);

  return FALSE;
}

void hmotion_visu_notify_event(GtkWidget *widget, GdkEventMotion *event, gpointer data)
{
  int x, y;
  int a,b;
  GdkModifierType state;
  GdkPixmap *pixmap_tmp;
  
  visuframe *fr=(visuframe *)data;

  gdk_window_get_pointer (event->window, &x, &y, &state);
  
  a=gadj_logical(fr->xadj, x);
  b=gadj_logical(fr->yadj, y);
  
  if(state & GDK_BUTTON1_MASK && fr->pixmap != NULL) {
    trans_x=(trans_x_base+(a-x_base)) % 256;
    trans_y=(trans_y_base+(b-y_base)) % 256;
  }

  if(state & GDK_BUTTON2_MASK && fr->pixmap != NULL) {
    rotat_x=(rotat_x_base+(a-x_base)) % 256;
    rotat_y=(rotat_y_base+(b-y_base)) % 256;
  }

  if(state & GDK_BUTTON3_MASK && fr->pixmap != NULL) {
    scale_y=(scale_y_base+(b-y_base)) % 256;
  }
  /* Pour le Double Buffering */
  /******************************************************************************/

  pixmap_tmp=fr->pixmap;

  fr->pixmap=gdk_pixmap_new(widget->window, WIN_WIDTH, WIN_HEIGHT, -1);

  draw_visu(fr->pixmap);
  gtk_widget_draw (fr->drawing_area, NULL);
    
  /*  if(pixmap_tmp)
    gdk_pixmap_unref(pixmap_tmp);
  */
  /********************************************************************************/


  /*  draw_visu();
  gtk_widget_draw(widget, NULL);
  */
}

int hbutton_visu_press_event(GtkWidget *widget, 
			GdkEventButton *event, 
			gpointer data)
{
  visuframe *fr=(visuframe *)data;

  trans_x_base=trans_x;
  trans_y_base=trans_y;
  rotat_x_base=rotat_x;
  rotat_y_base=rotat_y;
  scale_y_base=scale_y;

  x_base=gadj_logical(fr->xadj, event->x);
  y_base=gadj_logical(fr->yadj, event->y);

  return TRUE;
}

visuframe *init_visu(char *text)
{

  GtkWidget *drawing_area, *label, *hbox, *frame;

  visu=(visuframe *)malloc(sizeof(mframe));

  drawing_area = gtk_drawing_area_new();
  gtk_widget_show(drawing_area);
  
  gtk_signal_connect (GTK_OBJECT (drawing_area), "expose_event",
		      (GtkSignalFunc) hexpose_visu_event,        (gpointer)visu);
  gtk_signal_connect (GTK_OBJECT(drawing_area),  "configure_event",
		      (GtkSignalFunc) hconfigure_visu_event,     (gpointer)visu);
  gtk_signal_connect (GTK_OBJECT (drawing_area), "motion_notify_event",
		      (GtkSignalFunc) hmotion_visu_notify_event, (gpointer)visu);
  gtk_signal_connect (GTK_OBJECT (drawing_area), "button_press_event",
		      (GtkSignalFunc) hbutton_visu_press_event,  (gpointer)visu);
    
  gtk_widget_set_events (drawing_area, GDK_EXPOSURE_MASK
			 | GDK_LEAVE_NOTIFY_MASK
			 | GDK_BUTTON_PRESS_MASK
			 | GDK_BUTTON_MOTION_MASK
			 | GDK_POINTER_MOTION_HINT_MASK);
  
  visu->drawing_area=drawing_area;

  visu->pixmap=NULL;

  label=gtk_button_new_with_label(text);
  gtk_widget_show(label);

  frame=gtk_frame_new(NULL);
  gtk_widget_show(frame);
  gtk_container_add(GTK_CONTAINER(frame), drawing_area);
  gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_OUT);

  hbox=gtk_vbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(hbox), frame, TRUE, TRUE, 0);
  gtk_widget_show(hbox);

  gtk_signal_connect(GTK_OBJECT(label), "clicked",
		     GTK_SIGNAL_FUNC(expand_cb), (gpointer)hbox);

  visu->xadj=gadj_new(-1,-1);
  visu->yadj=gadj_new(-1,-1);

  visu->scw=hbox;
  return visu;
}

void x_put_pixel(int x, int y, int color) {
 
  GdkGC *gc;
  GdkColor pix_color;
  GdkColormap *colormap;
  
  gc=gdk_gc_new(window->window);
  colormap=gdk_window_get_colormap(window->window);

  pix_color.red=color&0xf;
  pix_color.green=(color>>8)&0xf;
  pix_color.blue=(color>>16)&0xf;
  gdk_color_alloc(colormap, &pix_color);
  gdk_gc_set_foreground(gc, &pix_color);
  
  gdk_draw_point(pixmap, gc, x, y);
}

void x_fill_rectangle(int x1, int y1,int x2, int y2, int color)
{
  GdkGC *gc;
  GdkColor pix_color;
  GdkColormap *colormap;

  gc=gdk_gc_new(window->window);
  colormap=gdk_window_get_colormap(window->window);

  pix_color.red=color&0xf;
  pix_color.green=(color>>8)&0xf;
  pix_color.blue=(color>>16)&0xf;
  
  gdk_color_alloc(colormap, &pix_color);
  gdk_gc_set_foreground(gc, &pix_color);

  gdk_draw_rectangle(pixmap, gc, TRUE, x1, y1, x2, y2);
}

void draw_visu(GdkDrawable *drawable)
{
}
